SystemOrganization addCategory: #'Monticello2-Elements'!
SystemOrganization addCategory: #'Monticello2-Fakes'!
SystemOrganization addCategory: #'Monticello2-Squeak'!
SystemOrganization addCategory: #'Monticello2-Tests'!
SystemOrganization addCategory: #'Monticello2-Versions'!

TestCase subclass: #MDTestSqueakMethodAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestSqueakMethodAdaptor methodsFor: 'constructing' stamp: 'cwp 2/5/2005 17:10'!
adaptor
	^ MDSqueakMethodAdaptor for: self element! !

!MDTestSqueakMethodAdaptor methodsFor: 'tests' stamp: 'cwp 2/5/2005 18:44'!
testLoad
	self adaptor load: self properties.
	self assertMethodHasDefaultProperties! !

!MDTestSqueakMethodAdaptor methodsFor: 'running' stamp: 'cwp 2/5/2005 17:27'!
tearDown
	self destroyMethod! !

!MDTestSqueakMethodAdaptor methodsFor: 'tests' stamp: 'cwp 2/5/2005 18:13'!
testIsUpToDate
	| method |
	self createMethod.
	method := self adaptor.
	self assert: (method isUpToDate: self properties)! !

!MDTestSqueakMethodAdaptor methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:56'!
timeStamp
	^ TimeStamp fromMethodTimeStamp: self stamp! !

!MDTestSqueakMethodAdaptor methodsFor: 'tests' stamp: 'cwp 2/5/2005 18:45'!
testUpdateSideEffects
	| properties |
	self createMethod.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assertMethodHasDefaultProperties! !

!MDTestSqueakMethodAdaptor methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:25'!
stamp
	^ 'abc 11/29/2004 01:44' ! !

!MDTestSqueakMethodAdaptor methodsFor: 'image access' stamp: 'cwp 2/5/2005 17:22'!
createMethod
	BogusC
		compile: self source
		classified: self category
		withStamp: self stamp
		notifying: nil
		logSource: true! !

!MDTestSqueakMethodAdaptor methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:24'!
category
	^ #temporary! !

!MDTestSqueakMethodAdaptor methodsFor: 'constructing' stamp: 'cwp 2/5/2005 17:20'!
element
	^ MDMethodElement className: #BogusC selector: #method1! !

!MDTestSqueakMethodAdaptor methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:23'!
source
	^ 'method1
	^ 1'! !

!MDTestSqueakMethodAdaptor methodsFor: 'image access' stamp: 'cwp 2/5/2005 17:27'!
destroyMethod
	BogusC removeSelector: #method1! !

!MDTestSqueakMethodAdaptor methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:55'!
author
	^ self stamp copyUpTo: $ ! !

!MDTestSqueakMethodAdaptor methodsFor: 'tests' stamp: 'cwp 2/5/2005 18:13'!
testIsPresent
	| method |
	self createMethod.
	method := self adaptor.
	self assert: method isPresent! !

!MDTestSqueakMethodAdaptor methodsFor: 'tests' stamp: 'cwp 2/5/2005 18:13'!
testRemove
	self createMethod.
	self adaptor remove.
	self deny: (BogusC includesSelector: #method1)! !

!MDTestSqueakMethodAdaptor methodsFor: 'tests' stamp: 'cwp 2/5/2005 17:32'!
testNotPresent
	| method |
	method := self adaptor.
	self deny: method isPresent! !

!MDTestSqueakMethodAdaptor methodsFor: 'tests' stamp: 'cwp 2/5/2005 18:04'!
testNotUpToDate
	| method properties |
	self createMethod.
	method := self adaptor.
	properties := self properties.
	properties category: #temp.
	self deny: (method isUpToDate: properties)! !

!MDTestSqueakMethodAdaptor methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:39'!
properties
	^ MDPropertyDictionary new
		author: self author;
		category: self category;
		source: self source;
		timeStamp: self timeStamp;
		yourself! !

!MDTestSqueakMethodAdaptor methodsFor: 'asserting' stamp: 'cwp 2/5/2005 18:46'!
assertMethodHasDefaultProperties
	self assert: (BogusC includesSelector: #method1).
	self assert: (BogusC organization categoryOfElement: #method1) = self category.
	self assert: (BogusC sourceCodeAt: #method1) = self source.
	self assert: (BogusC compiledMethodAt: #method1) timeStamp = self stamp.
! !

!MDTestSqueakMethodAdaptor methodsFor: 'tests' stamp: 'cwp 2/5/2005 18:20'!
testUpdate
	| properties |
	self createMethod.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assert: properties author = self author.
	self assert: properties category = self category.
	self assert: properties source = self source.
	self assert: properties timeStamp = self timeStamp! !

TestCase subclass: #MDTestCase
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestCase methodsFor: 'proxy access' stamp: 'cwp 2/4/2005 23:54'!
atElement: element property: property put: value
	"This will need to be overriden in tests that use a real image proxy."
	
	(proxy at: element) at: property put: value! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 2/5/2005 19:56'!
definition
	^ MDElementDefinition forElement: self element! !

MDTestCase subclass: #MDTestImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 2/5/2005 18:52'!
testCurrentDefinition
	| snap |
	self atElement: self element property: #one put: 1.
	snap := self definition.
	proxy updateSnapshot: snap.
	self assert: (snap properties at: #one) = 1
! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:44'!
testLoadRemoveAndUpdate
	| original retrieved |
	original _ self definition.
	original properties 
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadSnapshot: original.
	proxy loadSnapshot: self removal.
	retrieved _ proxy updateSnapshot: self definition.
	self assert: retrieved element = self element.
	self assert: retrieved isRemoval! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:43'!
testLoadDefinition
	| snap |
	snap _ self definition.
	snap properties 
			at: #one put: 1;
			at: #two put: 2;
			at: #three put: 3.
	proxy loadSnapshot: snap.
	self assert: (self atElement: self element property: #one) = 1.
	self assert: (self atElement: self element property: #two) = 2.
	self assert: (self atElement: self element property: #three) = 3.! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:47'!
testUpdateDoesntChangeElement
	| snap original |
	snap := self definition.
	original := snap element.
	proxy updateSnapshot: snap.
	self assert: snap element = original! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:46'!
testRemovalUpToDate
	| snap removal |
	snap _ self definition.
	removal _ self removal.
	snap properties foo: 'bar'.
	proxy loadSnapshot: snap.
	self deny: (proxy isUpToDate: removal).
	proxy loadSnapshot: removal.
	self assert: (proxy isUpToDate: removal)! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:38'!
testLoadAndUpdate
	| original retrieved |
	original _ self definition.
	original properties 
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadSnapshot: original.
	
	retrieved _ proxy updateSnapshot: self definition.
	self assert: original properties = retrieved properties! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:39'!
testLoadAndUpdateRemoval
	| original retrieved |
	original _ self definition.
	original properties 
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadSnapshot: original.
	retrieved _ proxy updateSnapshot: self removal.
	self assert: retrieved properties = original properties! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:45'!
testRemoval
	| snap |
	self atElement: self element property: #foo put: 'bar'.
	snap _ self removal.
	proxy loadSnapshot: snap.
	self assert: (self atElement: self element property: #foo) isNil! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:47'!
testUpToDate
	| snap |
	snap _ self definition.
	snap properties source: 'one ^ 1'.
	proxy loadSnapshot: snap.
	self assert: (proxy isUpToDate: snap).
	self atElement: self element property: #source put: 'one ^ 11'.
	self deny: (proxy isUpToDate: snap).! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 2/5/2005 19:56'!
removal
	^ MDElementRemoval forElement: self element! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 2/5/2005 19:56'!
element
	^ MDFakeElement named: #Alpha! !

!MDTestCase class methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2005 20:15'!
isAbstract
	^ self name = #MDTestCase! !

!MDTestCase methodsFor: 'constructing' stamp: 'avi 11/29/2004 14:13'!
updateVersion: anElementVersion property: aSymbol put: anObject
	| newSnapshot |
	newSnapshot _ anElementVersion snapshot copy.
	newSnapshot properties at: aSymbol put: anObject.
	^ MDElementVersion
		snapshot: newSnapshot
		ancestry: anElementVersion fullAncestry! !

!MDTestCase methodsFor: 'running' stamp: 'avi 11/29/2004 12:49'!
setUp
	proxy _ self proxyClass new! !

!MDTestCase methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:17'!
atProperty: aSymbol put: aValue
	self atElement: self element property: aSymbol put: aValue
! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 2/5/2005 19:57'!
version
	^ MDElementVersion snapshot: self definition! !

!MDTestCase methodsFor: 'proxy access' stamp: 'cwp 2/4/2005 23:53'!
atElement: element property: property
	"This will need to be overridden in real image proxy tests."
	
	^ (proxy at: element) at: property ifAbsent: [nil]! !

!MDTestCase methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:16'!
atProperty: aSymbol
	^ self atElement: self element property: aSymbol! !

!MDTestCase methodsFor: 'configuration' stamp: 'cwp 2/4/2005 23:58'!
proxyClass
	^ MDFakeImageProxy! !

MDTestCase subclass: #MDTestWorkingCopy
	instanceVariableNames: 'wc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestWorkingCopy methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:18'!
testModifyAndIncludeConflictingVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	self atProperty: #source put: 'three'.
	self assertConflictIncluding: newVersion! !

!MDTestWorkingCopy methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:00'!
testLoadAndSave
	| version |
	version _ self version.
	version snapshot properties foo: '1'.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version! !

!MDTestWorkingCopy methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:16'!
testLoad
	| version |
	version _ self version.
	version snapshot properties foo: 'bar'.
	wc loadVersion: version.
	self assert: (self atProperty: #foo) = 'bar'! !

!MDTestWorkingCopy methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:17'!
testLoadOldVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	wc loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	wc loadVersion: version.
	self assert: (self atProperty: #source) = 'one'.
! !

!MDTestWorkingCopy methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:17'!
testResolveConflict
	| version newVersion newVersion2 mergedVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	newVersion2 _ self updateVersion: version property: #source put: 'three'.
	wc loadVersion: newVersion.
	wc includeVersion: newVersion2 onConflict: [:a :b | b snapshot].
	self assert: (self atProperty: #source) = 'three'.
	mergedVersion _ wc versionForElement: version element.
	self assert: (mergedVersion snapshot = newVersion2 snapshot).
	self assert: (mergedVersion supercedes: newVersion).
	self assert: (mergedVersion supercedes: newVersion2).! !

!MDTestWorkingCopy methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:17'!
testLoadModifyAndSave
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version.
	self atProperty: #source put: 'two'.
	newVersion _ wc versionForElement: version element.
	self deny: newVersion == version.
	self assert: (newVersion supercedes: version).! !

!MDTestWorkingCopy methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:16'!
testIncludeOldVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	wc loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #source) = 'two'.
! !

!MDTestWorkingCopy methodsFor: 'asserting' stamp: 'avi 11/29/2004 14:55'!
assertNoConflictIncluding: anElementVersion
	wc includeVersion: anElementVersion onConflict: [:a :b | self assert: false. ^self]! !

!MDTestWorkingCopy methodsFor: 'asserting' stamp: 'avi 11/29/2004 14:55'!
assertConflictIncluding: anElementVersion
	wc includeVersion: anElementVersion onConflict: [:a :b | ^ self].
	self assert: false! !

!MDTestWorkingCopy methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:16'!
testIncludeNewVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	self assertNoConflictIncluding: newVersion.
	self assert: (self atProperty: #source) = 'two'! !

!MDTestWorkingCopy methodsFor: 'running' stamp: 'avi 11/29/2004 12:52'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy.! !

!MDTestWorkingCopy methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:12'!
testIncludeConflictingVersion
	| version newVersion newVersion2 |
	version _ self version.
	version snapshot properties source: 'one'.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	newVersion2 _ self updateVersion: version property: #source put: 'three'.
	wc loadVersion: newVersion.
	self assertConflictIncluding: newVersion2! !

Dictionary subclass: #MDPropertyDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDPropertyDictionary methodsFor: 'convenience' stamp: 'cwp 11/29/2004 00:49'!
doesNotUnderstand: aMessage
	aMessage selector isUnary ifTrue: [^ self at: aMessage selector ifAbsent: [nil]].
	(aMessage selector isKeyword
		and: [aMessage arguments size = 1])
			ifTrue: [^ self
						at: aMessage selector allButLast asSymbol
						put: aMessage arguments first].
	super doesNotUnderstand: aMessage.! !

Object subclass: #MDElementVersion
	instanceVariableNames: 'snapshot info ancestry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:54'!
fullAncestry
	^ ancestry copyWith: info! !

!MDElementVersion methodsFor: 'comparing' stamp: 'avi 11/29/2004 13:54'!
supercedes: anElementVersion
	^ self ancestry includes: anElementVersion info! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:17'!
snapshot
	^ snapshot! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:54'!
info
	^ info! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:56'!
snapshot: anElementSnapshot
	^ self snapshot: anElementSnapshot ancestry: Set new! !

!MDElementVersion methodsFor: 'initialize-release' stamp: 'avi 11/29/2004 12:31'!
initializeWithSnapshot: elementSnapshot ancestry: aCollection
	snapshot _ elementSnapshot.
	ancestry _ aCollection.
	info _ MDElementVersionInfo forSnapshot: snapshot! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:39'!
element
	^ snapshot element! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:31'!
snapshot: anElementSnapshot ancestry: aSet
	^ self basicNew initializeWithSnapshot: anElementSnapshot ancestry: aSet! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:53'!
ancestry
	^ ancestry! !

Object subclass: #MDSqueakElementAdaptor
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

MDSqueakElementAdaptor subclass: #MDSqueakMethodAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakMethodAdaptor class methodsFor: 'instance creation' stamp: 'cwp 2/3/2005 22:10'!
for: anElement
	^ self new setElement: anElement! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 23:06'!
category
	^ self elementClass organization categoryOfElement: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 23:05'!
elementClass
	^ self classNamed: element className! !

!MDSqueakMethodAdaptor methodsFor: 'private' stamp: 'cwp 2/3/2005 23:15'!
is: name upToDateIn: properties
	^ (properties at: name ifAbsent: [^ true]) = (self perform: name)
	! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 22:46'!
author
	^ self compiledMethod timeStamp copyUpTo: $ .! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 22:47'!
source
	^ (self classNamed: element className) 
		sourceCodeAt: (element selector).! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 00:22'!
update: properties
	properties 
		author: self author;
		timeStamp: self timeStamp;
		source: self source;
		category: self category! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/3/2005 23:11'!
isUpToDate: properties 
	self propertyNames
		do: [:property | (self is: property upToDateIn: properties) ifFalse: [^ false]].
	^ true
! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 23:12'!
propertyNames
	^ #(author timeStamp category source)! !

!MDSqueakMethodAdaptor methodsFor: 'private' stamp: 'cwp 2/3/2005 22:20'!
compiledMethod 
	^(self classNamed: element className) 
		compiledMethodAt: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/3/2005 23:01'!
load: properties
	| class |
	class := self classNamed: element className.
	class
		compile: (properties at: #source ifAbsent: [self source])
		classified: (properties at: #category ifAbsent: [self category])
		withStamp: (self stampFromProperties: properties)
		notifying: nil
		logSource: true! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/3/2005 23:19'!
remove
	self elementClass removeSelector: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'private' stamp: 'cwp 2/3/2005 22:29'!
stampFromProperties: properties
	| author timestamp |
	author _ properties at: #author ifAbsent: ['<nobody>'].
	timestamp _ properties at: #timeStamp ifAbsent: [^ '<no timestamp>'].
	^ String streamContents: 
		[:stream |
		stream nextPutAll: author.
		stream nextPut: $ .
	 	timestamp asDate printOn: stream format: #(2 1 3 $/ 1 1).
		stream nextPut: $ .
		timestamp asTime print24: true showSeconds: false on: stream]
		! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/3/2005 23:22'!
isPresent
	^ self elementClass includesSelector: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 22:48'!
timeStamp
	 ^ TimeStamp fromMethodTimeStamp: self compiledMethod timeStamp! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 22:21'!
classNamed: name 
	^ Smalltalk at: name asSymbol! !

!MDSqueakElementAdaptor methodsFor: 'initialize-release' stamp: 'cwp 2/5/2005 16:55'!
setElement: anElement
	element _ anElement! !

Object subclass: #MDWorkingCopy
	instanceVariableNames: 'proxy versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDWorkingCopy methodsFor: 'private' stamp: 'avi 11/29/2004 13:53'!
newVersionForElement: anImageElement
	| oldVersion newSnapshot |
	oldVersion _ versions at: anImageElement.
	newSnapshot _ oldVersion snapshot copy.
	proxy updateSnapshot: newSnapshot.
	^ MDElementVersion
		snapshot: newSnapshot
		ancestry: oldVersion fullAncestry! !

!MDWorkingCopy methodsFor: 'private' stamp: 'avi 11/29/2004 15:01'!
resolveConflictBetween: oldVersion and: newVersion using: aBlock
	| mergedSnapshot mergedVersion |
	mergedSnapshot _ aBlock value: oldVersion value: newVersion.
	mergedVersion _ MDElementVersion
						snapshot: mergedSnapshot
						ancestry: (oldVersion fullAncestry, newVersion fullAncestry).
	self loadVersion: mergedVersion! !

!MDWorkingCopy methodsFor: 'initialize-release' stamp: 'avi 11/29/2004 13:40'!
initializeWithImageProxy: anImageProxy
	proxy _ anImageProxy.
	versions _ Dictionary new! !

!MDWorkingCopy methodsFor: 'load and save' stamp: 'avi 11/29/2004 13:41'!
loadVersion: anElementVersion
	versions at: anElementVersion element put: anElementVersion.
	proxy loadSnapshot: anElementVersion snapshot! !

!MDWorkingCopy class methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 12:56'!
forImageProxy: anImageProxy
	^ self basicNew initializeWithImageProxy: anImageProxy! !

!MDWorkingCopy methodsFor: 'load and save' stamp: 'avi 11/29/2004 15:01'!
includeVersion: anElementVersion onConflict: twoArgBlock
	| currentVersion |
	currentVersion _ self versionForElement: anElementVersion element.
	(anElementVersion supercedes: currentVersion)
		ifTrue: [self loadVersion: anElementVersion. ^ true].
	(currentVersion supercedes: anElementVersion)
		ifTrue: [^ false].
	self resolveConflictBetween: currentVersion and: anElementVersion using: twoArgBlock.
	^ true! !

!MDWorkingCopy methodsFor: 'load and save' stamp: 'avi 11/29/2004 13:55'!
versionForElement: anImageElement
	| old |
	old _ versions at: anImageElement.
	^ (proxy isUpToDate: old snapshot)
		ifTrue: [old]
		ifFalse: [self newVersionForElement: anImageElement]! !

Object subclass: #MDImageElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
is: properties upToDateFor: anImageProxy
	^ (self adaptedFor: anImageProxy) isUpToDate: properties! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
update: properties from: anImageProxy
	^ (self adaptedFor: anImageProxy) update: properties! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
hash
	self subclassResponsibility ! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
removeFrom: anImageProxy
	^ (self adaptedFor: anImageProxy) remove! !

MDImageElement subclass: #MDMethodElement
	instanceVariableNames: 'className selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDMethodElement methodsFor: 'testing' stamp: 'cwp 2/4/2005 23:49'!
isMethodElement
	^ true! !

!MDMethodElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 22:09'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForMethodElement: self! !

!MDMethodElement methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:02'!
initializeWithClassName: aString selector: aSymbol
	className _ aString.
	selector _ aSymbol! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
selector
	^ selector! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 11/28/2004 15:23'!
hash
	^ (className, '|', selector) hash! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 11/28/2004 15:21'!
= other
	^ self class = other class 
		and: [className = other className] 
		and: [self selector = other selector]! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
className
	^ className! !

!MDMethodElement class methodsFor: 'as yet unclassified' stamp: 'avi 11/28/2004 16:02'!
className: aString selector: aSymbol
	^ self basicNew initializeWithClassName: aString selector: aSymbol! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
= other
	self subclassResponsibility ! !

!MDImageElement methodsFor: 'testing' stamp: 'cwp 2/4/2005 23:48'!
isMethodElement
	^ false! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
load: properties into: anImageProxy
	^ (self adaptedFor: anImageProxy) load: properties
! !

!MDImageElement methodsFor: 'adapting' stamp: 'cwp 2/3/2005 23:54'!
adaptedFor: anImageProxy
	self subclassResponsibility! !

MDImageElement subclass: #MDFakeElement
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 18:58'!
name: aSymbol
	name _ aSymbol! !

!MDFakeElement class methodsFor: 'instance creation' stamp: 'cwp 2/5/2005 19:02'!
named: aSymbol
	^ self new name: aSymbol! !

!MDFakeElement methodsFor: 'public' stamp: 'cwp 2/5/2005 19:03'!
adaptedFor: anImageProxy 
	^ anImageProxy adaptorForElement: self! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
= other
	self species = other species ifFalse: [^ false].
	^ self name = other name! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
hash
	^ name hash! !

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 18:58'!
name
	^ name! !

Object subclass: #MDElementRemoval
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDElementRemoval class methodsFor: 'as yet unclassified' stamp: 'avi 12/2/2004 01:23'!
forElement: anImageElement
	^ self basicNew initializeWithElement: anImageElement! !

!MDElementRemoval methodsFor: 'as yet unclassified' stamp: 'avi 12/2/2004 01:54'!
element
	^ element! !

!MDElementRemoval methodsFor: 'as yet unclassified' stamp: 'avi 12/2/2004 01:51'!
updateFrom: anImageProxy
	^ (MDElementDefinition forElement: element) updateFrom: anImageProxy! !

!MDElementRemoval methodsFor: 'as yet unclassified' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ true! !

!MDElementRemoval methodsFor: 'as yet unclassified' stamp: 'avi 12/2/2004 01:56'!
isUpToDateFor: anImageProxy
	^ (anImageProxy hasElement: element) not! !

!MDElementRemoval methodsFor: 'as yet unclassified' stamp: 'avi 12/2/2004 01:27'!
loadInto: anImageProxy
	element removeFrom: anImageProxy! !

!MDElementRemoval methodsFor: 'as yet unclassified' stamp: 'avi 12/2/2004 01:23'!
initializeWithElement: anImageElement
	element _ anImageElement! !

Object subclass: #MDImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/3/2005 23:56'!
hasElement: anElement
	^ (anElement adaptedFor: self) isPresent! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 12/2/2004 01:50'!
updateSnapshot: aSnapshot
	^ aSnapshot updateFrom: self! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/28/2004 16:07'!
loadSnapshot: aSnapshot
	aSnapshot loadInto: self! !

MDImageProxy subclass: #MDSqueakImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/3/2005 22:10'!
adaptorForMethodElement: anElement
	^ MDSqueakMethodAdaptor for: anElement! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/29/2004 13:26'!
isUpToDate: anElementSnapshot
	^ anElementSnapshot isUpToDateFor: self! !

MDImageProxy subclass: #MDFakeImageProxy
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/4/2005 00:23'!
removeKey: anElement
	dict removeKey: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/5/2005 19:05'!
adaptorForElement: anElement 
	^ MDFakeElementAdaptor
		forElement: anElement
		inImage: dict! !

!MDFakeImageProxy methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:23'!
initialize
	dict _ Dictionary new! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 15:25'!
at: anElement put: aPropertyDictionary
	dict at: anElement put: aPropertyDictionary! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/4/2005 00:28'!
includesKey: anElement 
	^ dict includesKey: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/5/2005 19:05'!
adaptorForMethodElement: aMethodElement 
	^ self adaptorForElement: aMethodElement! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/5/2005 16:08'!
at: anElement
	^ dict at: anElement ifAbsentPut: [Dictionary new]
! !

Object subclass: #MDElementDefinition
	instanceVariableNames: 'element properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDElementDefinition methodsFor: 'copying' stamp: 'avi 11/29/2004 14:16'!
copy
	| new |
	new _ self species forElement: element.
	properties keysAndValuesDo:
		[:k :v|
		new properties at: k put: v].
	^ new! !

!MDElementDefinition methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:06'!
properties
	^ properties! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'avi 12/2/2004 01:53'!
updateFrom: anImageProxy
	(anImageProxy hasElement: element) ifFalse: [^ MDElementRemoval forElement: element].
	element update: properties from: anImageProxy.
	^ self! !

!MDElementDefinition methodsFor: 'accessing' stamp: 'cwp 11/28/2004 12:56'!
element
	^ element! !

!MDElementDefinition methodsFor: 'initialize-release' stamp: 'cwp 11/29/2004 00:50'!
initializeWithElement: anElement
	element _ anElement.
	properties _ MDPropertyDictionary new! !

!MDElementDefinition class methodsFor: 'instance creation' stamp: 'cwp 11/28/2004 12:52'!
forElement: anElement
	^ self basicNew initializeWithElement: anElement! !

!MDElementDefinition methodsFor: 'testing' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ false! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'avi 11/29/2004 13:27'!
isUpToDateFor: anImageProxy
	^ element is: properties upToDateFor: anImageProxy! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:54'!
loadInto: anImageProxy
	element load: properties into: anImageProxy! !

Object subclass: #MDFakeElementAdaptor
	instanceVariableNames: 'image element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:32'!
load: properties 
	properties keysAndValuesDo: [:key :value | self properties at: key put: value]! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:39'!
isUpToDate: properties
	properties keysAndValuesDo: 
		[:key :value |
		(self properties at: key ifAbsent: [^ false]) = value ifFalse: [^ false]].
	^ true
	! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:33'!
update: properties
	self properties keysAndValuesDo: [:key :value | properties at: key put: value]! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:36'!
isPresent
	^ image includesKey: element! !

!MDFakeElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/4/2005 00:42'!
properties
	^ image at: element ifAbsentPut: [Dictionary new]! !

!MDFakeElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 2/4/2005 00:35'!
forElement: anElement inImage: aDictionary
	^ self new setImage: aDictionary element: anElement! !

!MDFakeElementAdaptor methodsFor: 'initialize-release' stamp: 'cwp 2/4/2005 00:34'!
setImage: aFakeImageProxy element: anElement
	image _ aFakeImageProxy.
	element _ anElement! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:40'!
remove
	image removeKey: element ifAbsent: []! !

Object subclass: #MDElementVersionInfo
	instanceVariableNames: 'timeStamp hash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDElementVersionInfo class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:32'!
forSnapshot: anElementSnapshot
	^ self basicNew initializeFromSnapshot: anElementSnapshot! !

!MDElementVersionInfo methodsFor: 'initialize-release' stamp: 'avi 11/29/2004 13:56'!
initializeFromSnapshot: anElementSnapshot
	timeStamp _ TimeStamp current.
	hash _ timeStamp hash.
	anElementSnapshot properties do:
		[:ea |
		hash _ hash bitXor: ea hash].
	! !

!MDElementVersionInfo methodsFor: 'accessing' stamp: 'avi 11/29/2004 12:34'!
timeStamp
	^ timeStamp! !

!MDElementVersionInfo methodsFor: 'accessing' stamp: 'avi 11/29/2004 12:34'!
hash
	^ hash! !

!MDElementVersionInfo methodsFor: 'comparing' stamp: 'avi 11/29/2004 12:35'!
= other
	^ other species = self species
		and: [other timeStamp = self timeStamp]
		and: [other hash = self hash]! !
